/* $USAGI: ipsec4_utils.h,v 1.3 2002/08/02 06:04:27 miyazawa Exp $ */
#include <net/ip.h>
#include <net/sadb.h>
#include <net/spd.h>

#ifdef __KERNEL__

int ipsec4_ah_calc(struct iphdr *iph, struct ip_auth_hdr *authhdr, struct ipsec_sp *policy);

int ipsec4_out_get_ahsize(struct ipsec_sp *policy);
int ipsec4_out_get_espsize(struct ipsec_sp *policy);
static inline int ipsec4_out_get_hdrsize(struct ipsec_sp *policy)
{
	return ipsec4_out_get_ahsize(policy) + ipsec4_out_get_espsize(policy);
}

void ipsec4_enc(const void *data, unsigned length, u8 proto,
		void **newdata, unsigned *newlength, struct ipsec_sp *policy);
void ipsec4_out_finish(struct ipsec_sp *policy_ptr);
#endif /* __KERNEL__ */
